/*  */

    .intel_syntax noprefix
    .global _entry_point

/*  */

    .include "template.in"

 /******************
  Uninitialised data
  ******************/

  .bss
    hWnd:           .long 0
    hInstance:      .long 0
    hCursor:        .long 0
    hIcon:          .long 0
    hButn1:         .long 0
    hButn2:         .long 0
    hButn3:         .long 0
    hButn4:         .long 0
    hFont:          .long 0
    hStatus:        .long 0
    swid:           .long 0
    shgt:           .long 0
    wwid:           .long 0
    whgt:           .long 0

.text

/*  */

_entry_point:

    InitCommonControls

    GetModuleHandle 0
    mov hInstance, eax

    LoadIcon 0,IDI_APPLICATION
    mov hIcon, eax

    LoadCursor 0,IDC_ARROW
    mov hCursor, eax

    GetSystemMetrics SM_CXSCREEN
    mov swid, eax

    GetSystemMetrics SM_CYSCREEN
    mov shgt, eax

    call main
    ExitProcess 0

/*  */

main:

    push ebp                    # create stack frame
    mov ebp, esp

    sub esp, 32

    WNDCLASSEX wc

    sztext szclassname, "gas_class"

    mov DWORD PTR wc.cbSize,        48
    mov DWORD PTR wc.style,         CS_BYTEALIGNWINDOW | CS_BYTEALIGNCLIENT
    mov DWORD PTR wc.lpfnWndProc,   OFFSET WndProc
    mov DWORD PTR wc.cbClsExtra,    0
    mov DWORD PTR wc.cbWndExtra,    0
    m2m wc.hInstance,               hInstance
    m2m wc.hIcon,                   hIcon
    m2m wc.hCursor,                 hCursor
    mov DWORD PTR wc.hbrBackground, COLOR_BTNFACE
    add DWORD PTR wc.hbrBackground, 1
    mov DWORD PTR wc.lpszMenuName,  0
    mov DWORD PTR wc.lpszClassName, OFFSET szclassname
    m2m wc.hIconSm,                 hIcon

    RegisterClassEx OFFSET(wc)

    GetPercent swid, 75
    mov DWORD PTR wwid, eax

    GetPercent shgt, 60
    mov DWORD PTR whgt, eax

    push swid
    push wwid
    call SetXY
    mov [ebp-32], eax

    push shgt
    push whgt
    call SetXY
    mov [ebp-28], eax

    sztext DisplayName,"GAS Window Template"

    CreateWindowEx WS_EX_LEFT,OFFSET(szclassname),OFFSET(DisplayName),WS_OVERLAPPEDWINDOW,[ebp-32],[ebp-28],wwid,whgt,0,0,hInstance,0
    mov hWnd, eax

   /************
    menu handles
    ************/
    .bss
      hMenu:    .long 0
      hfMnu:    .long 0
      heMnu:    .long 0
    .text

    CreateMenu
    mov hMenu, eax

    CreateMenu
    mov hfMnu, eax

    CreateMenu
    mov heMnu, eax

    sztext szfile,  "&File"
    AppendMenu hMenu,MF_POPUP,hfMnu,OFFSET(szfile)
    sztext szedit,  "&Edit"
    AppendMenu hMenu,MF_POPUP,heMnu,OFFSET(szedit)

    sztext sznew,   "&New\tCtrl+N"
    AppendMenu hfMnu,MF_STRING,1000,OFFSET(sznew)
    AppendMenu hfMnu,MF_SEPARATOR,0,0

    sztext szopen,  "&Open\tCtrl+O"
    AppendMenu hfMnu,MF_STRING,1001,OFFSET(szopen)
    AppendMenu hfMnu,MF_SEPARATOR,0,0

    sztext szquit,  "&Exit\tCtrl+Q"
    AppendMenu hfMnu,MF_STRING,53,OFFSET(szquit)

    sztext szundo,  "&Undo\tCtrl+Z"
    AppendMenu heMnu,MF_STRING,1100,OFFSET(szundo)
    AppendMenu heMnu,MF_SEPARATOR,0,0

    sztext szcut,   "&Cut\tCtrl+X"
    AppendMenu heMnu,MF_STRING,1101,OFFSET(szcut)
    sztext szcopy,  "C&opy\tCtrl+C"

    AppendMenu heMnu,MF_STRING,1102,OFFSET(szcopy)
    sztext szpaste, "&Paste\tCtrl+V"

    AppendMenu heMnu,MF_STRING,1103,OFFSET(szpaste)
    AppendMenu heMnu,MF_SEPARATOR,0,0

    sztext szclear, "C&lear\tDEL"
    AppendMenu heMnu,MF_STRING,1104,OFFSET(szclear)

    SetMenu hWnd,hMenu

    push SW_SHOW
    push 20
    push 25
    push hWnd
    call WindowFadeIn

    ShowWindow hWnd,SW_SHOW
    UpdateWindow hWnd

    call msgloop

    leave
    ret

/*  */

msgloop:

    MSG msg

  stlbl:
    TranslateMessage OFFSET(msg)
    DispatchMessage OFFSET(msg)
    GetMessage OFFSET(msg),0,0,0
    test eax, eax
    jnz stlbl

    ret

/**/

WndProc:

    push ebp                    # create stack frame
    mov ebp, esp

    PAINTSTRUCT ps
    RECT rct

  lb0:
    cmp_msg WM_COMMAND
    jne lb1
      cmp_wParam 50
      jne wlb1

        sztext ttitl, "Information ..."

        sztext dtxt1, "You pressed button 1"
        MessageBox [ebp+8],OFFSET(dtxt1),OFFSET(ttitl),MB_OK
        jmp defproc

    wlb1:
      cmp_wParam 51
      jne wlb2
        sztext dtxt2, "You pressed button 2"
        MessageBox [ebp+8],OFFSET(dtxt2),OFFSET(ttitl),MB_OK
        jmp defproc

    wlb2:
      cmp_wParam 52
      jne wlb3
        sztext dtxt3, "You pressed button 3"
        MessageBox [ebp+8],OFFSET(dtxt3),OFFSET(ttitl),MB_OK
        jmp defproc

    wlb3:
      cmp_wParam 53
      jne wlb4
        SendMessage [ebp+8],WM_SYSCOMMAND,SC_CLOSE,0
        jmp defproc

    wlb4:

  lb1:
    cmp_msg WM_PAINT
    jne lb2

      GetClientRect [ebp+8],OFFSET(rct)
      BeginPaint hWnd,OFFSET(ps)
      line [ebp+8],0x00111111,0,1,OFFSET(rct.right),1
      line [ebp+8],0x00EEEEEE,0,2,OFFSET(rct.right),2
      line [ebp+8],0x00111111,0,31,OFFSET(rct.right),31
      line [ebp+8],0x00EEEEEE,0,32,OFFSET(rct.right),32
      EndPaint hWnd,OFFSET(ps)
      xor eax, eax
      jmp quit

  lb2:
    cmp_msg WM_DESTROY
    jne lb3
      PostQuitMessage 0

  lb3:
    cmp_msg WM_CREATE
    jne lb4

      GetStockObject ANSI_VAR_FONT
      mov hFont, eax

      push_button [ebp+8],"Button 1",5,5,120,25,50
      mov hButn1, eax
      SendMessage hButn1,WM_SETFONT,hFont,-1

      push_button [ebp+8],"Button 2",125,5,120,25,51
      mov hButn2, eax
      SendMessage hButn2,WM_SETFONT,hFont,-1

      push_button [ebp+8],"Button 3",245,5,120,25,52
      mov hButn3, eax
      SendMessage hButn3,WM_SETFONT,hFont,-1

      push_button [ebp+8],"Close",365,5,120,25,53
      mov hButn4, eax
      SendMessage hButn4,WM_SETFONT,hFont,-1

      push [ebp+8]
      call status
      mov hStatus, eax

    jmp defproc

  lb4:
    cmp_msg WM_SIZE
    jne lb5

      MoveWindow hStatus,0,0,0,0,TRUE

    jmp quit

  lb5:

  defproc:
    DefaultProc

  quit:
    leave                       # exit stack frame
    ret 16

/**/

pbutn:

  # push_button hParent,ptext,x,y,wid,hgt,ID

    push ebp                    # create stack frame
    mov ebp, esp

    sztext buttonclass, "BUTTON"

    push 0
    push hInstance
    push [ebp+32]
    push [ebp+8]
    push [ebp+28]
    push [ebp+24]
    push [ebp+20]
    push [ebp+16]
    push WS_CHILD | WS_VISIBLE
    push [ebp+12]
    push OFFSET buttonclass
    push WS_EX_CLIENTEDGE
    call _CreateWindowExA@48

    leave                       # exit stack frame
    ret 28

/**/

status:

    push ebp                    # create stack frame
    mov ebp, esp

    sub esp, 28

    CreateStatusWindow WS_CHILD | WS_VISIBLE | SBS_SIZEGRIP,NULL,[ebp+8], 5000
    mov [ebp-28], eax

    mov DWORD PTR [ebp-24], 130     # Write status bar parts size
    mov DWORD PTR [ebp-20], 260
    mov DWORD PTR [ebp-16], 390
    mov DWORD PTR [ebp-12], -1

    lea edx, [ebp-24]

    SendMessage [ebp-28],SB_SETPARTS,4,edx

    mov eax, [ebp-28]

    leave
    ret 4

/**/

WindowFadeIn:

    # --------------------------------------------------
    # hWin      = handle of window to fade in.
    # msdelay   = delay between fade level changes
    # step      = incremental fade rate change up to 255
    # swattr    = ShowWindow style
    # --------------------------------------------------

    push ebp                                        # create stack frame
    mov ebp, esp

    sub esp, 16

    push esi
    xor esi, esi

    GetWindowLong [ebp+8],GWL_EXSTYLE               # get current window style
    mov [ebp-16], eax
    or eax,WS_EX_LAYERED
    SetWindowLong [ebp+8],GWL_EXSTYLE,eax           # add the WS_EX_LAYERED style

    SetLayeredWindowAttributes [ebp+8],0,0,2

    ShowWindow [ebp+8],[ebp+20]

  doloop:
    SetLayeredWindowAttributes [ebp+8],esi,esi,1 | 2
    Sleep [ebp+12]

    UpdateWindow hStatus
    UpdateWindow [ebp+8]

    add esi,[ebp+16]
    cmp esi,255
    jl doloop

    SetLayeredWindowAttributes [ebp+8],0,255,2
    UpdateWindow [ebp+8]

    SetWindowLong [ebp+8],GWL_EXSTYLE,[ebp-16]      # restore original window style

    pop esi

    leave
    ret 16

/**/

SetXY:

    mov eax, [esp+8]        # screen dimension
    sub eax, [esp+4]        # window dimension
    shr eax, 1

    ret 8

/**/





















